<a href="https://opensource.org/licenses/MIT" target="_blank">
  <img src="https://img.shields.io/badge/License-MIT-yellow.svg"/>
</a>
<a href="https://saythanks.io/to/bhoominn%40gmail.com" target="_blank">
  <img src="https://img.shields.io/badge/Say%20Thanks-!-1EAEDB.svg"/>
</a>
<a href="https://opensource.org/licenses/Apache-2.0" target="_blank">
  <img src="https://badges.frapsoft.com/os/v1/open-source.svg?v=102"/>
</a>

<a href="https://www.buymeacoffee.com/bhoominn" target="_blank"><img src="https://cdn.buymeacoffee.com/buttons/v2/default-yellow.png" alt="Buy Me A Coffee" width="195" height="55"></a>

## Show some love and like to support the project

## Intro
This package helps you daily usable function with ease. Just add nb_utils with its latest version and that's it you are ready to use.

## Documentation

[API Docs](https://pub.dev/documentation/nb_utils/latest/) are available.

## Installation

add this line to pubspec.yaml

```yaml

   dependencies:
     nb_utils: <latest_version>

```

import package

```dart

    import 'package:nb_utils/nb_utils.dart';

```

initialize nb_utils in main.dart file

```dart

    await initialize();

```

## Examples

```dart

    // Open a new screen
    HomePage().launch(context);

    // Remove all screens from back stack and opens new screen
    HomePage().launch(context, isNewTask: true);

    // Back to previous screen
    finish(context);

    // Get Color from hex string
    Color color = getColorFromHex('#FFFFF');
    
    // Hide soft keyboard
    hideKeyboard(context);
    
    // Padding All, Apply TextStyle
    Column(
      children: <Widget>[
         Text(item.title.validate(), style: boldTextStyle()),
      ],
    ).paddingAll(16)
    
    // Check given String is not null
    // validate() function verifies weather given String is null or not. if null then it returns blank String
    // validate() function prevents null object
    Text(item.title.validate()),
      
    // Apply Bold TextStyle
    Text(item.title.validate(), style: boldTextStyle())
    
    // Apply Primary TextStyle
    Text(item.title.validate(), style: primaryTextStyle())
    
    // Apply Secondary TextStyle
    Text(item.title.validate(), style: secondaryTextStyle())
    
    // Rounded Image
    Image.network(item.image, height: 250).cornerRadiusWithClipRRect(20)
    
    // Show a Widget (for ex here Circular Progress Bar) only if data is loading or doing some background task
    Center(child: CircularProgressIndicator()).visible(mIsLoading) 
    * mIsLoading is bool variable.
    
    // Center Widget
    CircularProgressIndicator().center() 

    // Click on ANY Widget
    Container(
      height: 100,
    ).onTap(() {
      // Handle Click
    })

    // Check Email Validation
    if(!emailController.text.validateEmail()) { 
      // Handle Email not valid
    } 
    
    // Check Phone Number Validation
    if(!phoneController.text.validatePhone()) {
      // Handle Phone Number not valid
    }
    
    // Capitalize First Letter
    'this is simple string'.capitalizeFirstLetter();

    // Toast a String
    toast('This is a string');

    // Toast a String for a long duration
    toastLong('This is a string');

    /// Prints only if in debug or profile mode - (parameter is Object)
    log('Your string');

    /// Change status bar Color and Brightness
    setStatusBarColor(Colors.blue);

    /// Set orientation to portrait
    setOrientationPortrait();

    /// Set orientation to landscape
    setOrientationLandscape();

    /// Get current PlatformName as a String
    platformName();

    /// Invoke Native method and get result
    invokeNativeMethod(CHANNEL_NAME, METHOD_NAME, [dynamic arguments]);

    /// return screen width
    context.width();

    /// return screen height
    context.height();
```

## 💰 Donations

If you would like to support the creator of this library or the continuous maintenance of this library, feel free to donate. Your donation is highly appreciated. Thank you!

**PayPal**

- **[Donate \$5](https://www.paypal.me/bhoomin/5)**: Thank's for creating this package, here's a tea for you!
- **[Donate \$10](https://www.paypal.me/bhoomin/10)**: Wow, I am stunned. Let me take you to the movies!
- **[Donate \$15](https://www.paypal.me/bhoomin/15)**: I really appreciate your work, let's grab some lunch!
- **[Donate \$25](https://www.paypal.me/bhoomin/25)**: That's some awesome stuff you did right there, dinner is on me!
- **[Donate \$50](https://www.paypal.me/bhoomin/50)**: I really really want to support this package, great job!
- **[Donate \$100](https://www.paypal.me/bhoomin/100)**: You are the man! This package saved me hours of struggle and hard work, simply awesome!

## Thank you